StreamTransformation Class Referenceabstract

Interface for the data processing portion of stream ciphers. More...

Inheritance diagram for StreamTransformation:

## Public Member Functions

StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | ProcessData (byte *outString, const byte *inString, size_t length)=0
| Encrypt or decrypt an array of bytes. More...
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt the last block of data. More...
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...
virtual bool | IsRandomAccess () const =0
| Determines whether the cipher supports random access. More...
virtual void | Seek (lword pos)
| Seek to an absolute position. More...
virtual bool | IsSelfInverting () const =0
| Determines whether the cipher is self-inverting. More...
virtual bool | IsForwardTransformation () const =0
| Determines if the cipher is being operated in its forward direction. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Detailed Description

Interface for the data processing portion of stream ciphers.

See also
  StreamTransformationFilter()

Definition at line 816 of file cryptlib.h.

## Member Function Documentation

## Ref()

StreamTransformation& StreamTransformation::Ref | ( |  | ) |

inline

Provides a reference to this object.

Returns
  A reference to this object

Useful for passing a temporary object to a function that takes a non-const reference

Definition at line 826 of file cryptlib.h.

## MandatoryBlockSize()

virtual unsigned int StreamTransformation::MandatoryBlockSize | ( |  | ) | const

inline virtual

Provides the mandatory block size of the cipher.

Returns
  The block size of the cipher if input must be processed in blocks, 1 otherwise

Reimplemented in BlockOrientedCipherModeBase.

Definition at line 830 of file cryptlib.h.

## OptimalBlockSize()

virtual unsigned int StreamTransformation::OptimalBlockSize | ( |  | ) | const

inline virtual

Provides the input block size most efficient for this cipher.

Returns
  The input block size that is most efficient for the cipher

The base class implementation returns MandatoryBlockSize().

Note
  Optimal input length is `n * OptimalBlockSize() - GetOptimalBlockSizeUsed()` for any `n > 0`.

Reimplemented in AdditiveCipherTemplate< BASE >, and ECB_OneWay.

Definition at line 837 of file cryptlib.h.

## GetOptimalBlockSizeUsed()

virtual unsigned int StreamTransformation::GetOptimalBlockSizeUsed | ( |  | ) | const

inline virtual

Provides the number of bytes used in the current block when processing at optimal block size.

Returns
  the number of bytes used in the current block when processing at the optimal block size

Definition at line 841 of file cryptlib.h.

## OptimalDataAlignment()

unsigned int StreamTransformation::OptimalDataAlignment | ( |  | ) | const

virtual

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

Reimplemented in AdditiveCipherTemplate< BASE >, CipherModeBase, GCM_Base, CCM_Base, and EAX_Base.

Definition at line 238 of file cryptlib.cpp.

## ProcessData()

virtual void StreamTransformation::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  |

pure virtual

Encrypt or decrypt an array of bytes.

Parameters

  outString | the output byte buffer
  inString | the input byte buffer
  length | the size of the input and output byte buffers, in bytes

Either `inString == outString`, or they must not overlap.

Implemented in CFB_CipherTemplate< AbstractPolicyHolder< CFB_CipherAbstractPolicy, SymmetricCipher > >, AdditiveCipherTemplate< BASE >, AdditiveCipherTemplate< AbstractPolicyHolder< AdditiveCipherAbstractPolicy, CTR_ModePolicy > >, CBC_Decryption, CBC_Encryption, ECB_OneWay, AuthenticatedSymmetricCipherBase, Weak::ARC4_Base, and PublicBlumBlumShub.

## ProcessLastBlock()

void StreamTransformation::ProcessLastBlock | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  |

virtual

Encrypt or decrypt the last block of data.

Parameters

  outString | the output byte buffer
  inString | the input byte buffer
  length | the size of the input and output byte buffers, in bytes ProcessLastBlock is used when the last block of data is special. Currently the only use of this function is CBC-CTS mode.

Reimplemented in CBC_CTS_Decryption, and CBC_CTS_Encryption.

Definition at line 248 of file cryptlib.cpp.

## ProcessString() [1/2]

void StreamTransformation::ProcessString | ( | byte * | inoutString,
|  | size_t | length
| ) |  |

inline

Encrypt or decrypt a string of bytes.

Parameters

  inoutString | the string to process
  length | the size of the inoutString, in bytes

Internally, the base class implementation calls ProcessData().

Definition at line 869 of file cryptlib.h.

## ProcessString() [2/2]

void StreamTransformation::ProcessString | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  |

inline

Encrypt or decrypt a string of bytes.

Parameters

  outString | the output string to process
  inString | the input string to process
  length | the size of the input and output strings, in bytes

Internally, the base class implementation calls ProcessData().

Definition at line 877 of file cryptlib.h.

## ProcessByte()

byte StreamTransformation::ProcessByte | ( | byte | input | ) |

inline

Encrypt or decrypt a byte.

Parameters

  input | the input byte to process

Internally, the base class implementation calls ProcessData() with a size of 1.

Definition at line 883 of file cryptlib.h.

## IsRandomAccess()

virtual bool StreamTransformation::IsRandomAccess | ( |  | ) | const

pure virtual

Determines whether the cipher supports random access.

Returns
  true if the cipher supports random access, false otherwise

Implemented in AdditiveCipherTemplate< BASE >, BlockOrientedCipherModeBase, BlumBlumShub, Weak::ARC4_Base, and AuthenticatedSymmetricCipherBase.

## Seek()

virtual void StreamTransformation::Seek | ( | lword | pos | ) |

inline virtual

Seek to an absolute position.

Parameters

  pos | position to seek

Exceptions

  NotImplemented |

The base class implementation throws NotImplemented. The function asserts IsRandomAccess() in debug builds.

Reimplemented in AdditiveCipherTemplate< BASE >, AdditiveCipherTemplate< AbstractPolicyHolder< AdditiveCipherAbstractPolicy, CTR_ModePolicy > >, and BlumBlumShub.

Definition at line 895 of file cryptlib.h.

## IsSelfInverting()

virtual bool StreamTransformation::IsSelfInverting | ( |  | ) | const

pure virtual

Determines whether the cipher is self-inverting.

Returns
  true if the cipher is self-inverting, false otherwise

IsSelfInverting determines whether this transformation is self-inverting (e.g. xor with a keystream).

Implemented in AdditiveCipherTemplate< BASE >, BlockOrientedCipherModeBase, Weak::ARC4_Base, PublicBlumBlumShub, and AuthenticatedSymmetricCipherBase.

## IsForwardTransformation()

virtual bool StreamTransformation::IsForwardTransformation | ( |  | ) | const

pure virtual

Determines if the cipher is being operated in its forward direction.

Returns
  true if DIR is ENCRYPTION, false otherwise

See also
  IsForwardTransformation(), IsPermutation(), GetCipherDirection()

Implemented in AdditiveCipherTemplate< BASE >, BlockOrientedCipherModeBase, GCM_Final< T_BlockCipher, T_TablesOption, T_IsEncryption >, CCM_Final< T_BlockCipher, T_DefaultDigestSize, T_IsEncryption >, EAX_Final< T_BlockCipher, T_IsEncryption >, Weak::ARC4_Base, and PublicBlumBlumShub.

The documentation for this class was generated from the following files:

- cryptlib.h
- cryptlib.cpp